local f = CreateFrame("Frame")

-- options
local spamWindow = 1 -- alter this number if you wish to filter channels to another window
local leaveGeneral = false
local leaveTrade = false
local leaveServices = true
--

local function leavechannels()
	if leaveGeneral then LeaveChannelByName("General") end
	if leaveTrade then LeaveChannelByName("Trade") end
	if leaveServices then LeaveChannelByName("Services") end
end

local function fixwindows()
	for i = 1, 10 do
		local cf = _G["ChatFrame"..i]
		if i == spamWindow then
			if not leaveGeneral then ChatFrame_AddChannel(cf, "General") end
			if not leaveTrade then ChatFrame_AddChannel(cf, "Trade") end
			if not leaveServices then ChatFrame_AddChannel(cf, "Services") end
		else
			ChatFrame_RemoveChannel(cf, "General")
			ChatFrame_RemoveChannel(cf, "Trade")
			ChatFrame_RemoveChannel(cf, "Services")
		end
	end
end

local function OnEvent(self, event, ...)
	if EnumerateServerChannels() then
		leavechannels()
	end
	fixwindows()
end

f:SetScript("OnEvent", OnEvent)
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("CHANNEL_UI_UPDATE")
